Index: /branches/OKB/HeuristicLab.Clients.OKB-3.3/Administrator.cs
===================================================================
--- /branches/OKB/HeuristicLab.Clients.OKB-3.3/Administrator.cs	(revision 4480)
+++ /branches/OKB/HeuristicLab.Clients.OKB-3.3/Administrator.cs	(revision 4481)
@@ -40,8 +40,17 @@
     }
 
+    #region Properties
     private ItemCollection<Platform> platforms;
     public ItemCollection<Platform> Platforms {
       get { return platforms; }
     }
+    private ItemCollection<DataType> dataTypes;
+    public ItemCollection<DataType> DataTypes {
+      get { return dataTypes; }
+    }
+    private IEnumerable<User> users;
+    public IEnumerable<User> Users {
+      get { return users; }
+    }
     private ItemCollection<AlgorithmClass> algorithmClasses;
     public ItemCollection<AlgorithmClass> AlgorithmClasses {
@@ -52,15 +61,17 @@
       get { return algorithms; }
     }
-    private ItemCollection<DataType> dataTypes;
-    public ItemCollection<DataType> DataTypes {
-      get { return dataTypes; }
-    }
-    private IEnumerable<User> users;
-    public IEnumerable<User> Users {
-      get { return users; }
-    }
+    private ItemCollection<ProblemClass> problemClasses;
+    public ItemCollection<ProblemClass> ProblemClasses {
+      get { return problemClasses; }
+    }
+    private ItemCollection<Problem> problems;
+    public ItemCollection<Problem> Problems {
+      get { return problems; }
+    }
+    #endregion
 
     private Administrator() { }
 
+    #region Refresh
     public void Refresh() {
       OnRefreshing();
@@ -70,4 +81,9 @@
       }
       platforms.Clear();
+      if (dataTypes == null) {
+        dataTypes = new ItemCollection<DataType>();
+        dataTypes.ItemsRemoved += new CollectionItemsChangedEventHandler<DataType>(dataTypes_ItemsRemoved);
+      }
+      dataTypes.Clear();
       if (algorithmClasses == null) {
         algorithmClasses = new ItemCollection<AlgorithmClass>();
@@ -80,17 +96,24 @@
       }
       algorithms.Clear();
-      if (dataTypes == null) {
-        dataTypes = new ItemCollection<DataType>();
-        dataTypes.ItemsRemoved += new CollectionItemsChangedEventHandler<DataType>(dataTypes_ItemsRemoved);
-      }
-      dataTypes.Clear();
+      if (problemClasses == null) {
+        problemClasses = new ItemCollection<ProblemClass>();
+        problemClasses.ItemsRemoved += new CollectionItemsChangedEventHandler<ProblemClass>(problemClasses_ItemsRemoved);
+      }
+      problemClasses.Clear();
+      if (problems == null) {
+        problems = new ItemCollection<Problem>();
+        problems.ItemsRemoved += new CollectionItemsChangedEventHandler<Problem>(problems_ItemsRemoved);
+      }
+      problems.Clear();
 
       var call = new Func<Exception>(delegate() {
         try {
           platforms.AddRange(CallAdminService<Platform[]>(s => s.GetPlatforms()).OrderBy(x => x.Name));
+          dataTypes.AddRange(CallAdminService<DataType[]>(s => s.GetDataTypes()).OrderBy(x => x.Name));
+          users = CallAuthenticationService<User[]>(s => s.GetUsers()).OrderBy(x => x.Name);
           algorithmClasses.AddRange(CallAdminService<AlgorithmClass[]>(s => s.GetAlgorithmClasses()).OrderBy(x => x.Name));
           algorithms.AddRange(CallAdminService<Algorithm[]>(s => s.GetAlgorithms()).OrderBy(x => x.Name));
-          dataTypes.AddRange(CallAdminService<DataType[]>(s => s.GetDataTypes()).OrderBy(x => x.Name));
-          users = CallAuthenticationService<User[]>(s => s.GetUsers()).OrderBy(x => x.Name);
+          problemClasses.AddRange(CallAdminService<ProblemClass[]>(s => s.GetProblemClasses()).OrderBy(x => x.Name));
+          problems.AddRange(CallAdminService<Problem[]>(s => s.GetProblems()).OrderBy(x => x.Name));
           return null;
         }
@@ -105,15 +128,36 @@
       }, null);
     }
-
+    #endregion
+
+    #region Store
     public bool Store(IOKBItem item) {
       try {
-        if (item is Platform)
-          CallAdminService(s => s.StorePlatform((Platform)item));
-        else if (item is AlgorithmClass)
-          CallAdminService(s => s.StoreAlgorithmClass((AlgorithmClass)item));
-        else if (item is Algorithm)
-          CallAdminService(s => s.StoreAlgorithm((Algorithm)item));
-        else if (item is DataType)
-          CallAdminService(s => s.StoreDataType((DataType)item));
+        if (item.Id == 0) {
+          if (item is Platform)
+            item.Id = CallAdminService<long>(s => s.AddPlatform((Platform)item));
+          else if (item is DataType)
+            item.Id = CallAdminService<long>(s => s.AddDataType((DataType)item));
+          else if (item is AlgorithmClass)
+            item.Id = CallAdminService<long>(s => s.AddAlgorithmClass((AlgorithmClass)item));
+          else if (item is Algorithm)
+            item.Id = CallAdminService<long>(s => s.AddAlgorithm((Algorithm)item));
+          else if (item is ProblemClass)
+            item.Id = CallAdminService<long>(s => s.AddProblemClass((ProblemClass)item));
+          else if (item is Problem)
+            item.Id = CallAdminService<long>(s => s.AddProblem((Problem)item));
+        } else {
+          if (item is Platform)
+            CallAdminService(s => s.UpdatePlatform((Platform)item));
+          else if (item is DataType)
+            CallAdminService(s => s.UpdateDataType((DataType)item));
+          else if (item is AlgorithmClass)
+            CallAdminService(s => s.UpdateAlgorithmClass((AlgorithmClass)item));
+          else if (item is Algorithm)
+            CallAdminService(s => s.UpdateAlgorithm((Algorithm)item));
+          else if (item is ProblemClass)
+            CallAdminService(s => s.UpdateProblemClass((ProblemClass)item));
+          else if (item is Problem)
+            CallAdminService(s => s.UpdateProblem((Problem)item));
+        }
         return true;
       }
@@ -123,5 +167,7 @@
       }
     }
-
+    #endregion
+
+    #region Algorithm Methods
     public Guid[] GetAlgorithmUsers(long algorithmId) {
       try {
@@ -133,26 +179,77 @@
       }
     }
-    public bool StoreAlgorithmUsers(long algorithmId, Guid[] users) {
-      try {
-        CallAdminService(s => s.StoreAlgorithmUsers(algorithmId, users));
-        return true;
-      }
-      catch (Exception ex) {
-        ErrorHandling.ShowErrorDialog("Store authorized algorithm users failed.", ex);
-        return false;
-      }
-    }
-
-    public bool StoreAlgorithmData(AlgorithmData algorithmData) {
-      try {
-        CallAdminService(s => s.StoreAlgorithmData(algorithmData));
-        return true;
-      }
-      catch (Exception ex) {
-        ErrorHandling.ShowErrorDialog("Store serialized algorithm failed.", ex);
-        return false;
-      }
-    }
-
+    public bool UpdateAlgorithmUsers(long algorithmId, Guid[] users) {
+      try {
+        CallAdminService(s => s.UpdateAlgorithmUsers(algorithmId, users));
+        return true;
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Update authorized algorithm users failed.", ex);
+        return false;
+      }
+    }
+    public AlgorithmData GetAlgorithmData(long algorithmId) {
+      try {
+        return CallAdminService<AlgorithmData>(s => s.GetAlgorithmData(algorithmId));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Refresh algorithm data failed.", ex);
+        return null;
+      }
+    }
+    public bool UpdateAlgorithmData(AlgorithmData algorithmData) {
+      try {
+        CallAdminService(s => s.UpdateAlgorithmData(algorithmData));
+        return true;
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Update algorithm data failed.", ex);
+        return false;
+      }
+    }
+    #endregion
+
+    #region Problem Methods
+    public Guid[] GetProblemUsers(long problemId) {
+      try {
+        return CallAdminService<Guid[]>(s => s.GetProblemUsers(problemId));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Refresh authorized problem users failed.", ex);
+        return null;
+      }
+    }
+    public bool UpdateProblemUsers(long problemId, Guid[] users) {
+      try {
+        CallAdminService(s => s.UpdateProblemUsers(problemId, users));
+        return true;
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Update authorized problem users failed.", ex);
+        return false;
+      }
+    }
+    public ProblemData GetProblemData(long problemId) {
+      try {
+        return CallAdminService<ProblemData>(s => s.GetProblemData(problemId));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Refresh problem data failed.", ex);
+        return null;
+      }
+    }
+    public bool UpdateProblemData(ProblemData problemData) {
+      try {
+        CallAdminService(s => s.UpdateProblemData(problemData));
+        return true;
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Update problem data failed.", ex);
+        return false;
+      }
+    }
+    #endregion
+
+    #region Events
     public event EventHandler Refreshing;
     private void OnRefreshing() {
@@ -175,4 +272,13 @@
       }
     }
+    private void dataTypes_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<DataType> e) {
+      try {
+        foreach (DataType d in e.Items)
+          CallAdminService(s => s.DeleteDataType(d.Id));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Delete failed.", ex);
+      }
+    }
     private void algorithmClasses_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<AlgorithmClass> e) {
       try {
@@ -193,13 +299,23 @@
       }
     }
-    private void dataTypes_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<DataType> e) {
-      try {
-        foreach (DataType d in e.Items)
-          CallAdminService(s => s.DeleteDataType(d.Id));
-      }
-      catch (Exception ex) {
-        ErrorHandling.ShowErrorDialog("Delete failed.", ex);
-      }
-    }
+    private void problemClasses_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<ProblemClass> e) {
+      try {
+        foreach (ProblemClass p in e.Items)
+          CallAdminService(s => s.DeleteProblemClass(p.Id));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Delete failed.", ex);
+      }
+    }
+    private void problems_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<Problem> e) {
+      try {
+        foreach (Problem p in e.Items)
+          CallAdminService(s => s.DeleteProblem(p.Id));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Delete failed.", ex);
+      }
+    }
+    #endregion
 
     #region Helpers
@@ -218,5 +334,5 @@
       }
     }
-    private T CallAdminService<T>(Func<IAdminService, T> call) where T : class {
+    private T CallAdminService<T>(Func<IAdminService, T> call) {
       AdminServiceClient client = ClientFactory.CreateClient<AdminServiceClient, IAdminService>();
       try {
@@ -232,5 +348,5 @@
       }
     }
-    private T CallAuthenticationService<T>(Func<IAuthenticationService, T> call) where T : class {
+    private T CallAuthenticationService<T>(Func<IAuthenticationService, T> call) {
       AuthenticationServiceClient client = ClientFactory.CreateClient<AuthenticationServiceClient, IAuthenticationService>();
       try {
Index: /branches/OKB/HeuristicLab.Clients.OKB-3.3/HeuristicLab.Clients.OKB-3.3.csproj
===================================================================
--- /branches/OKB/HeuristicLab.Clients.OKB-3.3/HeuristicLab.Clients.OKB-3.3.csproj	(revision 4480)
+++ /branches/OKB/HeuristicLab.Clients.OKB-3.3/HeuristicLab.Clients.OKB-3.3.csproj	(revision 4481)
@@ -53,7 +53,9 @@
       <HintPath>..\..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.MainForm.WindowsForms-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.Optimization-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Optimizer-3.3">
       <HintPath>..\..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.Optimizer-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.Persistence-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
       <HintPath>..\..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
@@ -85,4 +87,7 @@
     </Compile>
     <Compile Include="ServiceClients\AuthenticationServiceClient.cs" />
+    <Compile Include="ServiceClients\AlgorithmData.cs" />
+    <Compile Include="ServiceClients\Problem.cs" />
+    <Compile Include="ServiceClients\ProblemClass.cs" />
     <Compile Include="ServiceClients\DataType.cs" />
     <Compile Include="ServiceClients\NamedOKBItem.cs" />
@@ -121,4 +126,22 @@
       <DependentUpon>AlgorithmView.cs</DependentUpon>
     </Compile>
+    <Compile Include="Views\AlgorithmDataView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Views\AlgorithmDataView.Designer.cs">
+      <DependentUpon>AlgorithmDataView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Views\ProblemCollectionView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Views\ProblemCollectionView.Designer.cs">
+      <DependentUpon>ProblemCollectionView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Views\ProblemClassCollectionView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Views\ProblemClassCollectionView.Designer.cs">
+      <DependentUpon>ProblemClassCollectionView.cs</DependentUpon>
+    </Compile>
     <Compile Include="Views\DataTypeView.cs">
       <SubType>UserControl</SubType>
@@ -161,6 +184,6 @@
   </ItemGroup>
   <ItemGroup>
-    <EmbeddedResource Include="Views\AdministratorView.resx">
-      <DependentUpon>AdministratorView.cs</DependentUpon>
+    <EmbeddedResource Include="Views\AlgorithmDataView.resx">
+      <DependentUpon>AlgorithmDataView.cs</DependentUpon>
     </EmbeddedResource>
     <EmbeddedResource Include="Views\AlgorithmView.resx">
Index: /branches/OKB/HeuristicLab.Clients.OKB-3.3/HeuristicLabClientsOKBPlugin.cs.frame
===================================================================
--- /branches/OKB/HeuristicLab.Clients.OKB-3.3/HeuristicLabClientsOKBPlugin.cs.frame	(revision 4480)
+++ /branches/OKB/HeuristicLab.Clients.OKB-3.3/HeuristicLabClientsOKBPlugin.cs.frame	(revision 4481)
@@ -36,5 +36,7 @@
   [PluginDependency("HeuristicLab.MainForm", "3.3")]
   [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
   [PluginDependency("HeuristicLab.Optimizer", "3.3")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3")]
   public class HeuristicLabClientsOKBPlugin : PluginBase {
   }
